SystemOrganization addCategory: #'Athens-PangoCairo'!

Trait named: #TPangoCairoLibrary
	uses: {}
	category: 'Athens-PangoCairo'!

!TPangoCairoLibrary classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 1/17/2012 11:48'!
nbLibraryNameOrHandle
	^ '/opt/local/lib/libpangocairo-1.0.0.dylib'! !

!TPangoCairoLibrary classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 1/17/2012 11:54'!
pangoLibraryNameOrHandle
	^ '/opt/local/lib/libpango-1.0.0.dylib'! !

!TPangoCairoLibrary classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 3/9/2012 14:55'!
pangoNbCall: fnSpec 
	
	| sender |
	
	sender := thisContext sender.

	^ NBFFICallout  
		handleFailureIn: sender
		nativeCode: [ :gen |
			gen
				sender: sender;
				callType: self nbCallingConvention;
				generateCall: fnSpec module: self pangoLibraryNameOrHandle]
! !

!TPangoCairoLibrary methodsFor: 'initialization' stamp: 'FernandoOlivero 1/17/2012 11:48'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle
! !

!TPangoCairoLibrary methodsFor: 'initialization' stamp: 'FernandoOlivero 1/17/2012 11:54'!
pangoLibraryNameOrHandle
	^ self class pangoLibraryNameOrHandle! !

!TPangoCairoLibrary methodsFor: 'initialization' stamp: 'FernandoOlivero 3/9/2012 14:55'!
pangoNbCall: fnSpec 
	
	| sender |
	
	sender := thisContext sender.

	^ NBFFICallout  
		handleFailureIn: sender
		nativeCode: [ :gen |
			gen
				sender: sender;
				callType: self nbCallingConvention;
				generateCall: fnSpec module: self pangoLibraryNameOrHandle]
! !

SharedPool subclass: #PangoCairoConstants
	instanceVariableNames: ''
	classVariableNames: 'PANGO_ALIGN_CENTER PANGO_ALIGN_LEFT PANGO_ALIGN_RIGHT PANGO_DIRECTION_LTR PANGO_DIRECTION_NEUTRAL PANGO_DIRECTION_RTL PANGO_DIRECTION_TTB_LTR PANGO_DIRECTION_TTB_RTL PANGO_DIRECTION_WEAK_LTR PANGO_DIRECTION_WEAK_RTL PANGO_ELLIPSIZE_END PANGO_ELLIPSIZE_MIDDLE PANGO_ELLIPSIZE_NONE PANGO_ELLIPSIZE_START PANGO_FONT_MASK_FAMILY PANGO_FONT_MASK_GRAVITY PANGO_FONT_MASK_SIZE PANGO_FONT_MASK_STRETCH PANGO_FONT_MASK_STYLE PANGO_FONT_MASK_VARIANT PANGO_FONT_MASK_WEIGHT PANGO_GRAVITY_AUTO PANGO_GRAVITY_EAST PANGO_GRAVITY_NORTH PANGO_GRAVITY_SOUTH PANGO_GRAVITY_WEST PANGO_SCALE PANGO_STRETCH_CONDENSED PANGO_STRETCH_EXPANDED PANGO_STRETCH_EXTRA_CONDENSED PANGO_STRETCH_EXTRA_EXPANDED PANGO_STRETCH_NORMAL PANGO_STRETCH_SEMI_CONDENSED PANGO_STRETCH_SEMI_EXPANDED PANGO_STRETCH_ULTRA_CONDENSED PANGO_STRETCH_ULTRA_EXPANDED PANGO_STYLE_ITALIC PANGO_STYLE_NORMAL PANGO_STYLE_OBLIQUE PANGO_VARIANT_NORMAL PANGO_VARIANT_SMALL_CAPS PANGO_WEIGHT_BOLD PANGO_WEIGHT_BOOK PANGO_WEIGHT_HEAVY PANGO_WEIGHT_LIGHT PANGO_WEIGHT_MEDIUM PANGO_WEIGHT_NORMAL PANGO_WEIGHT_SEMIBOLD PANGO_WEIGHT_THIN PANGO_WEIGHT_ULTRABOLD PANGO_WEIGHT_ULTRAHEAVY PANGO_WEIGHT_ULTRALIGHT PANGO_WRAP_CHAR PANGO_WRAP_WORD PANGO_WRAP_WORD_CHAR'
	poolDictionaries: ''
	category: 'Athens-PangoCairo'!

!PangoCairoConstants commentStamp: 'FernandoOlivero 1/17/2012 14:40' prior: 0!
self initialize!

Object subclass: #AthensPangoCairoRectangle
	instanceVariableNames: 'x y width height'
	classVariableNames: ''
	poolDictionaries: 'PangoCairoConstants'
	category: 'Athens-PangoCairo'!

!AthensPangoCairoRectangle commentStamp: 'FernandoOlivero 2/5/2012 17:17' prior: 0!
PangoRectangle

typedef struct {
  int x;
  int y;
  int width;
  int height;
} PangoRectangle; !

!AthensPangoCairoRectangle methodsFor: 'accessing' stamp: 'FernandoOlivero 2/28/2012 13:06'!
asByteArray
	| bigEndian array |
	"4 ints = 4 * 4 bytes =  16 bytes "
	array := ByteArray new:  16.
	bigEndian := Smalltalk isBigEndian.
	array longAt: 1 put: x * PANGO_SCALE bigEndian: bigEndian.
	array longAt: 5 put: y * PANGO_SCALE bigEndian: bigEndian. 
	array longAt: 9 put: width * PANGO_SCALE bigEndian: bigEndian.
	array longAt: 13 put: height * PANGO_SCALE bigEndian: bigEndian.	
	^ array 
! !

!AthensPangoCairoRectangle methodsFor: 'accessing' stamp: 'FernandoOlivero 2/5/2012 17:28'!
extent
	^ width@height! !

!AthensPangoCairoRectangle methodsFor: 'accessing' stamp: 'FernandoOlivero 2/5/2012 17:16'!
height

	^ height! !

!AthensPangoCairoRectangle methodsFor: 'initialize-release' stamp: 'FernandoOlivero 2/5/2012 17:34'!
initialize
	x := y := width := height := 0.! !

!AthensPangoCairoRectangle methodsFor: 'accessing' stamp: 'FernandoOlivero 2/5/2012 18:37'!
origin
	^ x@y ! !

!AthensPangoCairoRectangle methodsFor: 'accessing' stamp: 'FernandoOlivero 2/5/2012 17:37'!
pangoScale
	^ PANGO_SCALE! !

!AthensPangoCairoRectangle methodsFor: 'initialize-release' stamp: 'FernandoOlivero 2/28/2012 13:06'!
readFrom: aByteArray
	| bigEndian |
	bigEndian := Smalltalk isBigEndian.
	x :=  ( (aByteArray longAt: 1 bigEndian: bigEndian) / self pangoScale ) rounded.
	y := ( ( aByteArray longAt: 5 bigEndian: bigEndian ) / self pangoScale ) rounded.
	width := ( ( aByteArray longAt: 9 bigEndian: bigEndian ) / self pangoScale ) rounded.
	height := ( ( aByteArray longAt: 13 bigEndian: bigEndian ) / self pangoScale ) rounded.! !

!AthensPangoCairoRectangle methodsFor: 'accessing' stamp: 'FernandoOlivero 2/5/2012 17:16'!
width

	^ width! !

!AthensPangoCairoRectangle methodsFor: 'accessing' stamp: 'FernandoOlivero 2/5/2012 17:16'!
x

	^ x! !

!AthensPangoCairoRectangle methodsFor: 'accessing' stamp: 'FernandoOlivero 2/5/2012 17:16'!
y

	^ y! !

!PangoCairoConstants classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 12/13/2011 16:52'!
initialize
	self
		initializeAlignment;
		initializeEllipsizeMode;
		initializeWrapMode;
		initializeStyle;
		initializeFontMask;
		initializeVariant ;
		initializeWeight;
		initializeStretch;
		initializeScale;
		initializeGravity ;
		initializeDirection .! !

!PangoCairoConstants classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 12/10/2011 20:24'!
initializeAlignment
"typedef enum {"
  PANGO_ALIGN_LEFT := 0.
  PANGO_ALIGN_CENTER := 1.
  PANGO_ALIGN_RIGHT := 2.
"} PangoAlignment;"! !

!PangoCairoConstants classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 12/13/2011 16:53'!
initializeDirection 
"	typedef enum {"
  PANGO_DIRECTION_LTR := 0.
  PANGO_DIRECTION_RTL:= 1.
  PANGO_DIRECTION_TTB_LTR:= 2.
  PANGO_DIRECTION_TTB_RTL:= 3.
  PANGO_DIRECTION_WEAK_LTR:= 4.
  PANGO_DIRECTION_WEAK_RTL:= 5.
  PANGO_DIRECTION_NEUTRAL:= 6.
"} PangoDirection;"! !

!PangoCairoConstants classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 12/10/2011 20:23'!
initializeEllipsizeMode
"typedef enum {"
  PANGO_ELLIPSIZE_NONE := 0.
  PANGO_ELLIPSIZE_START := 1.
  PANGO_ELLIPSIZE_MIDDLE := 2.
  PANGO_ELLIPSIZE_END := 3.
"} PangoEllipsizeMode;"! !

!PangoCairoConstants classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 12/10/2011 23:02'!
initializeFontMask
"	typedef enum {"
 PANGO_FONT_MASK_FAMILY  := 1 << 0.
  PANGO_FONT_MASK_STYLE   := 1 << 1.
  PANGO_FONT_MASK_VARIANT := 1 << 2.
  PANGO_FONT_MASK_WEIGHT  := 1 << 3.
  PANGO_FONT_MASK_STRETCH := 1 << 4.
  PANGO_FONT_MASK_SIZE    := 1 << 5.
  PANGO_FONT_MASK_GRAVITY := 1 << 6
"} PangoFontMask;"! !

!PangoCairoConstants classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 12/13/2011 16:38'!
initializeGravity 
"	typedef enum {"
  PANGO_GRAVITY_SOUTH := 0. 
  PANGO_GRAVITY_EAST := 1.
  PANGO_GRAVITY_NORTH := 2.
  PANGO_GRAVITY_WEST := 3.
  PANGO_GRAVITY_AUTO := 4.
"} PangoGravity;"! !

!PangoCairoConstants classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 12/11/2011 00:42'!
initializeScale
	PANGO_SCALE := 1024.
	! !

!PangoCairoConstants classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 12/10/2011 23:01'!
initializeStretch
"	typedef enum {"
  PANGO_STRETCH_ULTRA_CONDENSED := 0.
  PANGO_STRETCH_EXTRA_CONDENSED := 1.
  PANGO_STRETCH_CONDENSED := 2.
  PANGO_STRETCH_SEMI_CONDENSED := 3.
  PANGO_STRETCH_NORMAL := 4.
  PANGO_STRETCH_SEMI_EXPANDED := 5.
  PANGO_STRETCH_EXPANDED := 6.
  PANGO_STRETCH_EXTRA_EXPANDED := 7.
  PANGO_STRETCH_ULTRA_EXPANDED := 8.
"} PangoStretch;"! !

!PangoCairoConstants classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 12/10/2011 22:57'!
initializeStyle
"	typedef enum {"
  PANGO_STYLE_NORMAL := 0.
  PANGO_STYLE_OBLIQUE := 1.
  PANGO_STYLE_ITALIC := 2.
"} PangoStyle;"! !

!PangoCairoConstants classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 12/10/2011 23:00'!
initializeVariant
"	typedef enum {"
  PANGO_VARIANT_NORMAL := 0.
  PANGO_VARIANT_SMALL_CAPS := 1.
"} PangoVariant;"! !

!PangoCairoConstants classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 12/10/2011 22:59'!
initializeWeight
"	typedef enum {"
  PANGO_WEIGHT_THIN := 100.
  PANGO_WEIGHT_ULTRALIGHT := 200.
  PANGO_WEIGHT_LIGHT := 300.
  PANGO_WEIGHT_BOOK := 380.
  PANGO_WEIGHT_NORMAL := 400.
  PANGO_WEIGHT_MEDIUM := 500.
  PANGO_WEIGHT_SEMIBOLD := 600.
  PANGO_WEIGHT_BOLD := 700.
  PANGO_WEIGHT_ULTRABOLD := 800.
  PANGO_WEIGHT_HEAVY := 900.
  PANGO_WEIGHT_ULTRAHEAVY := 1000.
"} PangoWeight;"! !

!PangoCairoConstants classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 12/10/2011 20:22'!
initializeWrapMode
"typedef enum {"
  PANGO_WRAP_WORD := 0.
  PANGO_WRAP_CHAR := 1.
  PANGO_WRAP_WORD_CHAR := 2.
! !

SharedPool subclass: #PangoCairoTypes
	instanceVariableNames: ''
	classVariableNames: 'PangoAlignment PangoCairoFontMap PangoContext PangoDirection PangoEllipsizeMode PangoFontDescription PangoFontMap PangoGravity PangoLanguage PangoLayout PangoLayoutIter PangoLayoutLine PangoTabArray PangoWrapMode gboolean'
	poolDictionaries: ''
	category: 'Athens-PangoCairo'!

Object subclass: #AthensPangoCairoExternalObject
	uses: TPangoCairoLibrary
	instanceVariableNames: 'handle'
	classVariableNames: ''
	poolDictionaries: 'PangoCairoConstants PangoCairoTypes'
	category: 'Athens-PangoCairo'!

AthensPangoCairoExternalObject class
	uses: TPangoCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensPangoCairoExternalObject classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 2/5/2012 19:59'!
asNBExternalType: gen
	"use handle ivar to hold my instance"
	^ NBExternalObjectType objectClass: self! !

!AthensPangoCairoExternalObject methodsFor: 'initialization' stamp: 'FernandoOlivero 2/5/2012 19:23'!
finalize
	handle value = 0 ifFalse: [
		self primFree.
		handle value: 0
		 ].
! !

AthensPangoCairoExternalObject subclass: #AthensPangoCairoFontDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'PangoCairoTypes'
	category: 'Athens-PangoCairo'!

!AthensPangoCairoFontDescription commentStamp: 'FernandoOlivero 1/17/2012 13:45' prior: 0!
Creates a new font description from a string representation in the form [FAMILY-LIST] [STYLE-OPTIONS] [SIZE], where FAMILY-LIST is a comma separated list of families optionally terminated by a comma, 

STYLE_OPTIONS is a whitespace separated list of words where each WORD describes one of style, variant, weight, stretch, or gravity,

 and SIZE is a decimal number (size in points) or optionally followed by the unit modifier 'px' for absolute size. Any one of the options may be absent. 

If FAMILY-LIST is absent, then the family_name field of the resulting font description will be initialized to NULL. If STYLE-OPTIONS is missing, then all style options will be set to the default values. If SIZE is missing, the size in the resulting font description will be set to 0.!

!AthensPangoCairoFontDescription classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 2/12/2012 18:38'!
fromString: aString
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	^self pangoNbCall:#(PangoFontDescription pango_font_description_from_string (char * aString))
	! !

!AthensPangoCairoFontDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 13:36'!
asString
	^ self primToString.! !

!AthensPangoCairoFontDescription methodsFor: 'testing' stamp: 'FernandoOlivero 1/17/2012 13:34'!
isAbsolute
":
whether the size for the font description is in points or device units. Use pango_font_description_get_set_fields() to find out if the size field of the font description was explicitly set or not.
"
	^ self primIsAbsolute
! !

!AthensPangoCairoFontDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 16:43'!
loadOn: anAthensParagraph
	anAthensParagraph setFontDescription: self.! !

!AthensPangoCairoFontDescription methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/17/2012 13:40'!
primFree
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	self pangoNbCall:#(void pango_font_description_free (PangoFontDescription self))
! !

!AthensPangoCairoFontDescription methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/17/2012 13:34'!
primIsAbsolute
<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	^ self pangoNbCall: #(gboolean pango_font_description_get_size_is_absolute (
			PangoFontDescription self))

! !

!AthensPangoCairoFontDescription methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/17/2012 13:36'!
primToString
	
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self pangoNbCall:#(String pango_font_description_to_string (PangoFontDescription self)).! !

AthensPangoCairoExternalObject subclass: #AthensPangoCairoParagraphIterator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-PangoCairo'!

!AthensPangoCairoParagraphIterator methodsFor: 'initialize-release' stamp: 'FernandoOlivero 2/5/2012 19:25'!
primFree
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	self pangoNbCall:#(void  pango_layout_iter_free  (self))
! !

AthensPangoCairoExternalObject subclass: #AthensPangoCairoTabs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'PangoCairoTypes'
	category: 'Athens-PangoCairo'!

!AthensPangoCairoTabs classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 1/17/2012 18:38'!
getFrom: anAthensParagraph
	
	^ self pangoNbCall: #(PangoTabArray   pango_layout_get_tabs (PangoLayout anAthensParagraph))! !

!AthensPangoCairoTabs classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 3/6/2012 23:54'!
primNewSize: aSize pixels: positionsInPixels firstAlignment: anAlignment firstOffset: offset
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self pangoNbCall:#(PangoTabArray  pango_tab_array_new_with_positions  (int aSize,
                                                         int positionsInPixels,
                                                         int anAlignment,
                                                         int offset))! !

!AthensPangoCairoTabs classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 1/17/2012 23:19'!
tabs: aCollectionOfTabs
	| tabs |
	tabs := self
		primNewSize: aCollectionOfTabs size
		pixels: 1
		firstAlignment: 0
		firstOffset: aCollectionOfTabs first.
	aCollectionOfTabs allButFirst withIndexDo:[:each :i| tabs at: i -1 put: each].
	^ tabs	
		
	! !

!AthensPangoCairoTabs methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 22:54'!
asArray
	| arr numberOfStops |
	numberOfStops := self primNumberOfStops.
	arr := Array new: numberOfStops.
	1 to:	numberOfStops do:[:i|
		|pair|
		pair := self primGetTabStopAt: i.
		arr at: i put: pair value]. 
	^ arr! !

!AthensPangoCairoTabs methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 22:56'!
at: anIndex put: aLocation
	self primSetTab: anIndex alignment: 0 location: aLocation! !

!AthensPangoCairoTabs methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 23:06'!
loadOn: anAthensParagraph
	self primSetTabsOn: anAthensParagraph.
	! !

!AthensPangoCairoTabs methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/17/2012 18:20'!
primFree
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	self pangoNbCall:#(void pango_tab_array_free (PangoTabArray self))
! !

!AthensPangoCairoTabs methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/17/2012 22:54'!
primGetTabStopAt: anIndex
"	void                pango_tab_array_get_tab             (PangoTabArray *tab_array,
                                                         gint tab_index,
                                                         PangoTabAlign *alignment,
                                                         gint *location);"
	^ 0->8! !

!AthensPangoCairoTabs methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/17/2012 19:09'!
primNumberOfStops
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
		
	^ self pangoNbCall: #(int  pango_tab_array_get_size  (PangoTabArray self))	! !

!AthensPangoCairoTabs methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/17/2012 22:57'!
primSetTab: index alignment: alignment location: location
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	self pangoNbCall:#(void  pango_tab_array_set_tab (
				PangoTabArray self,
    			int index,
       			int alignment,
          		int location))! !

!AthensPangoCairoTabs methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/17/2012 18:32'!
primSetTabsOn: anAthensParagraph

 	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
		
	self pangoNbCall: #(void  pango_layout_set_tabs (
					PangoLayout anAthensParagraph,
					PangoTabArray self) )
! !

AthensPangoCairoExternalObject subclass: #AthensPangoCairoFontDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'PangoCairoTypes'
	category: 'Athens-PangoCairo'!

!AthensPangoCairoFontDescription commentStamp: 'FernandoOlivero 1/17/2012 13:45' prior: 0!
Creates a new font description from a string representation in the form [FAMILY-LIST] [STYLE-OPTIONS] [SIZE], where FAMILY-LIST is a comma separated list of families optionally terminated by a comma, 

STYLE_OPTIONS is a whitespace separated list of words where each WORD describes one of style, variant, weight, stretch, or gravity,

 and SIZE is a decimal number (size in points) or optionally followed by the unit modifier 'px' for absolute size. Any one of the options may be absent. 

If FAMILY-LIST is absent, then the family_name field of the resulting font description will be initialized to NULL. If STYLE-OPTIONS is missing, then all style options will be set to the default values. If SIZE is missing, the size in the resulting font description will be set to 0.!

AthensPangoCairoExternalObject subclass: #AthensPangoCairoTabs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'PangoCairoTypes'
	category: 'Athens-PangoCairo'!

NBExternalObject subclass: #AthensPangoCairoText
	uses: TPangoCairoLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs PangoCairoConstants PangoCairoTypes'
	category: 'Athens-PangoCairo'!

AthensPangoCairoText class
	uses: TPangoCairoLibrary classTrait
	instanceVariableNames: ''!

AthensPangoCairoText subclass: #AthensPangoCairoParagraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-PangoCairo'!

!AthensPangoCairoParagraph classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 1/17/2012 13:57'!
newIn: aCairoCanvas 
"Creates a layout object set up to match the current transformation and target surface of the Cairo context. This layout can then be used for text measurement with functions like pango_layout_get_size() or drawing with functions like pango_cairo_show_layout(). If you change the transformation or target surface for cr, you need to call pango_cairo_update_layout()

This function is the most convenient way to use Cairo with Pango, however it is slightly inefficient since it creates a separate PangoContext object for each layout. This might matter in an application that was laying out large amounts of text."
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(PangoLayout pango_cairo_create_layout (cairo_t  aCairoCanvas ) )
! !

!AthensPangoCairoParagraph methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 12:23'!
asString
	^ self primGetText! !

!AthensPangoCairoParagraph methodsFor: 'accessing' stamp: 'FernandoOlivero 2/28/2012 13:16'!
cursorPositionsAt: anIndex
	| strong strongArray weak weakArray |
	strong := AthensPangoCairoRectangle new.
	strongArray := strong asByteArray.
	weak := AthensPangoCairoRectangle new.
	weakArray := weak asByteArray.
	self
		primGetCursorPosAt: anIndex 
		strong: strongArray 
		weak: weakArray .
	strong readFrom: strongArray.
	weak readFrom: weakArray.
	^ {strong.  weak}! !

!AthensPangoCairoParagraph methodsFor: 'geometry' stamp: 'FernandoOlivero 1/18/2012 01:15'!
ellipsizeHeight
	| h |
	h := self primGetHeight.
	h = -1 ifTrue:[ ^ h] ifFalse:[ ^ h / PANGO_SCALE]! !

!AthensPangoCairoParagraph methodsFor: 'geometry' stamp: 'FernandoOlivero 1/18/2012 01:15'!
ellipsizeHeight: aPositiveIntOrMinusOne
	"Sets the height to which the PangoLayout should be ellipsized at. There are two different behaviors, based on whether height is positive or negative.

If height is positive, it will be the maximum height of the layout. Only lines would be shown that would fit, and if there is any text omitted, an ellipsis added. At least one line is included in each paragraph regardless of how small the height value is. A value of zero will render exactly one line for the entire layout.

If height is negative, it will be the (negative of) maximum number of lines per paragraph. That is, the total number of lines shown may well be more than this value if the layout contains multiple paragraphs of text. The default value of -1 means that first line of each paragraph is ellipsized. This behvaior may be changed in the future to act per layout instead of per paragraph. File a bug against pango at http://bugzilla.gnome.org/ if your code relies on this behavior.

Height setting only has effect if a positive width is set on layout and ellipsization mode of layout is not PANGO_ELLIPSIZE_NONE. The behavior is undefined if a height other than -1 is set and ellipsization mode is set to PANGO_ELLIPSIZE_NONE, and may change in the future."

	aPositiveIntOrMinusOne = -1 
		ifTrue:[self primSetHeight: aPositiveIntOrMinusOne]
		ifFalse:[self primSetHeight: aPositiveIntOrMinusOne	* PANGO_SCALE]
	 ! !

!AthensPangoCairoParagraph methodsFor: 'geometry' stamp: 'FernandoOlivero 3/2/2012 17:04'!
extent
	|width height bigEndian w h|
	width := ByteArray new:4.
	height :=  ByteArray new:4.
	self primGetSizeWidth: width height: height.
	bigEndian := Smalltalk isBigEndian.
	w :=  ( (width longAt: 1 bigEndian: bigEndian) /  PANGO_SCALE ) rounded.
	h :=  ( (height longAt: 1 bigEndian: bigEndian) /  PANGO_SCALE ) rounded.
	^ w @ h! !

!AthensPangoCairoParagraph methodsFor: 'accessing' stamp: 'FernandoOlivero 2/5/2012 21:51'!
fontDescription
	^ self primGetFontDescription.
	! !

!AthensPangoCairoParagraph methodsFor: 'fonts' stamp: 'FernandoOlivero 1/17/2012 13:19'!
fontDescriptionString
	|desc string |
	desc := self primGetFontDescription.
	string := desc asString.
	desc finalize.
	^ string ! !

!AthensPangoCairoParagraph methodsFor: 'testing' stamp: 'FernandoOlivero 1/17/2012 14:23'!
isEllipsized  
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	^ self pangoNbCall:#(Bool   pango_layout_is_ellipsized  (PangoLayout self))
	! !

!AthensPangoCairoParagraph methodsFor: 'testing' stamp: 'FernandoOlivero 1/17/2012 14:23'!
isWrapped 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	^ self pangoNbCall:#(Bool  pango_layout_is_wrapped (PangoLayout self))
	! !

!AthensPangoCairoParagraph methodsFor: 'accessing' stamp: 'FernandoOlivero 2/5/2012 19:19'!
iterator
	^ self primGetIterator.
	! !

!AthensPangoCairoParagraph methodsFor: 'accessing' stamp: 'FernandoOlivero 2/5/2012 20:27'!
lineAt: aLineNumber
	^ AthensPangoCairoParagraphLine at: aLineNumber in: self
	
	! !

!AthensPangoCairoParagraph methodsFor: 'accessing' stamp: 'FernandoOlivero 2/5/2012 19:55'!
lineAtIndex: anIndex
	| line x i |
	line := ByteArray new: 4.
	x := ByteArray new: 4.
	self primIndex: anIndex toLine: line x: x trailing:1.
	i := line unsignedLongAt: 1 bigEndian: Smalltalk isBigEndian.
	^ self lineAt: i.! !

!AthensPangoCairoParagraph methodsFor: 'accessing' stamp: 'FernandoOlivero 2/12/2012 18:02'!
linesPerParagraph: aNumber  wrappedTo: aWidth
"
If height is negative, it will be the (negative of) maximum number of lines per paragraph. That is, the total number of lines shown may well be more than this value if the layout contains multiple paragraphs of text. The default value of -1 means that first line of each paragraph is ellipsized. This behvaior may be changed in the future to act per layout instead of per paragraph. File a bug against pango at http://bugzilla.gnome.org/ if your code relies on this behavior.
"

"Height setting only has effect if a positive width is set on layout and ellipsization mode of layout is not PANGO_ELLIPSIZE_NONE. "

	self ellipsizeHeight: aNumber rounded negated ; wrapWidth: aWidth rounded! !

!AthensPangoCairoParagraph methodsFor: 'accessing' stamp: 'FernandoOlivero 4/28/2012 19:38'!
markup: aString
"Sets the layout text and attribute list from marked-up text (see markup format). Replaces the current text and attribute list.
http://developer.gnome.org/pango/stable/PangoMarkupFormat.html "
	aString isNil ifTrue:[ ^ self ].
	self primSetMarkup: aString length: aString size ! !

!AthensPangoCairoParagraph methodsFor: 'accessing' stamp: 'FernandoOlivero 1/18/2012 01:18'!
maximumHeight: aHeight wrappedTo: aWidth
	"If height is positive, it will be the maximum height of the layout. Only lines would be shown that would fit, and if there is any text omitted, an ellipsis added. At least one line is included in each paragraph regardless of how small the height value is. A value of zero will render exactly one line for the entire layout."

"Height setting only has effect if a positive width is set on layout and ellipsization mode of layout is not PANGO_ELLIPSIZE_NONE. "
	
	self ellipsizeHeight: aHeight  ; wrapWidth: aWidth! !

!AthensPangoCairoParagraph methodsFor: 'accessing' stamp: 'FernandoOlivero 2/28/2012 22:31'!
nextCursorPositionFrom: anIndex
	forward: forward
	advance: advance
	|biggie  towards intArray trailingIntArray trailing charOffset index  |
	"if 0, the cursor was at the trailing edge of the grapheme indicated by old_index, if > 0, the cursor was at the leading edge."
	forward 
		ifTrue:[ trailing :=   0 ]
		ifFalse:[ trailing :=   1 ].
	"A negative value indicates motion to the left."
	advance
		ifTrue:[ towards :=   0 ]
		ifFalse:[ towards :=   -1 ].
	intArray := ByteArray new: 4.
	trailingIntArray := ByteArray new: 4.
	self 
		primMoveCursorVisuallyStrong: 1
		from: anIndex 
		trailing: trailing 
		towards: towards 
		storeNextIn: intArray
		storeNextTrailingIn: trailingIntArray. 
	biggie := Smalltalk isBigEndian.	
	index := intArray longAt: 1 bigEndian: biggie.
	charOffset := trailingIntArray longAt: 1 bigEndian: biggie.
	":
number of characters to move forward from the location returned for new_index to get the position where the cursor should be displayed. This allows distinguishing the position at the beginning of one line from the position at the end of the preceding line. new_index is always on the line where the cursor should be displayed."
	
	^ {index . charOffset}! !

!AthensPangoCairoParagraph methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 12:21'!
numberOfLines
	^	self primGetLineCount! !

!AthensPangoCairoParagraph methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 21:43'!
pangoScale
	^ PANGO_SCALE! !

!AthensPangoCairoParagraph methodsFor: 'geometry' stamp: 'FernandoOlivero 2/5/2012 20:11'!
positionAt: anIndex
	| rect array |
	rect := AthensPangoCairoRectangle new.
	array :=  rect asByteArray.
	self primIndexToPosition: anIndex fill: array.
	rect readFrom: array.
	^ rect origin	


! !

!AthensPangoCairoParagraph methodsFor: 'private' stamp: 'FernandoOlivero 4/28/2012 18:59'!
primClearAttributes
	
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self pangoNbCall: #(void  pango_layout_set_attributes  (self,  nil) )
! !

!AthensPangoCairoParagraph methodsFor: 'apply primitives' stamp: 'FernandoOlivero 2/7/2012 23:39'!
primErrorUnderlineCurrentPathOf: aNBCairoContext
	atX: x
	y: y
	width: w
	height: h
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #(void pango_cairo_error_underline_path    (
			 cairo_t aCairoCanvas,
                                                         double x,
                                                         double y,
                                                         double  w,
                                                         double  h) )! !

!AthensPangoCairoParagraph methodsFor: 'apply primitives' stamp: 'FernandoOlivero 2/5/2012 22:58'!
primGetCursorPosAt: index strong: strongArray weak: weakArray
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self pangoNbCall: #(void  pango_layout_get_cursor_pos (
			self,
			int index,
			ByteArray strongArray,
			ByteArray weakArray ))! !

!AthensPangoCairoParagraph methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/17/2012 12:39'!
primGetFontDescription
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	^ self pangoNbCall:#(PangoFontDescription  pango_layout_get_font_description ( PangoLayout self ) ) ! !

!AthensPangoCairoParagraph methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/17/2012 12:20'!
primGetHeight
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self pangoNbCall: #(int  pango_layout_get_height (PangoLayout self))
					! !

!AthensPangoCairoParagraph methodsFor: 'private' stamp: 'FernandoOlivero 2/5/2012 19:20'!
primGetIterator
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	self pangoNbCall:#(PangoLayoutIter *   pango_layout_get_iter  (self) )
 ! !

!AthensPangoCairoParagraph methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/17/2012 12:21'!
primGetLineCount
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	^ self pangoNbCall:#(int pango_layout_get_line_count  (PangoLayout self) )! !

!AthensPangoCairoParagraph methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/18/2012 01:18'!
primGetSizeWidth: aWordW height: aWordH
	
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self pangoNbCall: #(void  pango_layout_get_size (
			PangoLayout self,
			int* aWordW,
			int* aWordH)).
					
! !

!AthensPangoCairoParagraph methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/17/2012 12:20'!
primGetText 

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self pangoNbCall: #(String  pango_layout_get_text (PangoLayout self))! !

!AthensPangoCairoParagraph methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/17/2012 12:20'!
primGetWidth
	"	 the width in Pango units, or -1 if no width set. "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self pangoNbCall: #(int  pango_layout_get_width (PangoLayout self))
					! !

!AthensPangoCairoParagraph methodsFor: 'private' stamp: 'FernandoOlivero 2/5/2012 19:52'!
primIndex: index toLine: line x: x trailing: anBooleanInt
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	self pangoNbCall: #(void                pango_layout_index_to_line_x        (self,
                                                         int index,
                                                         int anBooleanInt,
                                                         int *line,
                                                         int *x)).
! !

!AthensPangoCairoParagraph methodsFor: 'private' stamp: 'FernandoOlivero 2/5/2012 17:22'!
primIndexToPosition: anIndex fill: aByteArray
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	self pangoNbCall:#(void  pango_layout_index_to_pos (
		self,
  		int anIndex,
		ByteArray aByteArray) )				
! !

!AthensPangoCairoParagraph methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/17/2012 12:03'!
primLayoutPath: aCairoCanvas 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	"Adds the text in a PangoLayout to the current path in the specified cairo context. The top-left corner of the PangoLayout will be at the current point of the cairo context."
	^ self nbCall: #(void pango_cairo_layout_path (
		cairo_t aCairoCanvas, 
		self) )
! !

!AthensPangoCairoParagraph methodsFor: 'apply primitives' stamp: 'FernandoOlivero 2/28/2012 14:01'!
primMoveCursorVisuallyStrong: aBooleanInt
	from: anCursorIndex 
	trailing: aTrailingInt 
	towards: directionInt 
	storeNextIn: aByteArray
	storeNextTrailingIn: nextTrailingByteArray 
	
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self pangoNbCall: #(void pango_layout_move_cursor_visually   (self,
                                                         int aBooleanInt,
                                                         int anCursorIndex,
                                                         int aTrailingInt,
                                                         int directionInt,
                                                         int * aByteArray,
                                                         int * nextTrailingByteArray))! !

!AthensPangoCairoParagraph methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/17/2012 16:45'!
primSetFontDescription: anAthensPangoCairoFontDescription

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	self pangoNbCall: #(void pango_layout_set_font_description  (
			self,
   			PangoFontDescription anAthensPangoCairoFontDescription))! !

!AthensPangoCairoParagraph methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/17/2012 16:05'!
primSetHeight: aHeight
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self pangoNbCall: #(void  pango_layout_set_height (
					PangoLayout self,
					int aHeight) )

! !

!AthensPangoCairoParagraph methodsFor: 'private' stamp: 'FernandoOlivero 4/28/2012 20:21'!
primSetMarkup: aMarkup length: aLength 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	self pangoNbCall:#(void  pango_layout_set_markup (
		  self ,
            char*  aMarkup,
            int aLength )) 
! !

!AthensPangoCairoParagraph methodsFor: 'apply primitives' stamp: 'FernandoOlivero 4/28/2012 19:06'!
primSetText: aString size: aStringSize
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self pangoNbCall: #(void  pango_layout_set_text (
					self,
					String aString,
					int aStringSize) ) ! !

!AthensPangoCairoParagraph methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/17/2012 15:31'!
primSetWidth: aWidth 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self pangoNbCall: #(void  pango_layout_set_width (
					PangoLayout self,
					int aWidth) )
					! !

!AthensPangoCairoParagraph methodsFor: 'apply primitives' stamp: 'FernandoOlivero 2/7/2012 23:38'!
primShowErrorUnderline: aCairoCanvas atX: x y: y width: w height: h 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #(void pango_cairo_show_error_underline 
			 (cairo_t aCairoCanvas,
                                                         double x,
                                                         double  y,
                                                         double w,
                                                         double h) )	! !

!AthensPangoCairoParagraph methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/17/2012 14:08'!
primShowLayout: aCairoCanvas 
	"The top-left corner of the PangoLayout will be drawn at the current point of the cairo context."
	
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void pango_cairo_show_layout (
			cairo_t aCairoCanvas, 
			PangoLayout self ) )
! !

!AthensPangoCairoParagraph methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/17/2012 12:08'!
primUnref
	"self unrefGLibObject: self"! !

!AthensPangoCairoParagraph methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/17/2012 14:08'!
primUpdateLayout: aCairoCanvas 
	"Updates the private PangoContext of a PangoLayout created with pango_cairo_create_layout() to match the current transformation and target surface of a Cairo context."
	" If you change the transformation or target surface for cr, you need to call pango_cairo_update_layout()"
	
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #(void pango_cairo_update_layout( 
		cairo_t aCairoCanvas, 
		PangoLayout self ) ) 
! !

!AthensPangoCairoParagraph methodsFor: 'fonts' stamp: 'FernandoOlivero 1/17/2012 16:43'!
setFontDescription: anAthensPangoCairoFontDescription
	self primSetFontDescription: anAthensPangoCairoFontDescription! !

!AthensPangoCairoParagraph methodsFor: 'fonts' stamp: 'FernandoOlivero 1/17/2012 16:46'!
setFontDescriptionFromString: aString
	| desc |
	desc := AthensPangoCairoFontDescription fromString: aString.
	desc loadOn: self.
	desc finalize. ! !

!AthensPangoCairoParagraph methodsFor: 'accessing' stamp: 'FernandoOlivero 4/28/2012 18:57'!
text: aString
	self
		primClearAttributes ;
		primSetText: aString size: aString size! !

!AthensPangoCairoParagraph methodsFor: 'accessing' stamp: 'FernandoOlivero 4/28/2012 20:20'!
text: aString markup: aMarkup 
"
Sets the layout text and attribute list from marked-up text (see markup format). Replaces the current text and attribute list.
http://developer.gnome.org/pango/stable/PangoMarkupFormat.html

"
	(aMarkup isNil or:[ aMarkup isEmpty ] )  
		ifTrue: [
			self primClearAttributes .
			self primSetText: aString size: aString size]
		ifFalse: [ 
			| cstring |
			cstring := aMarkup , (Character value:0) asString.		 
			self primSetMarkup: cstring length: aMarkup size].
	
	! !

!AthensPangoCairoParagraph methodsFor: 'accessing' stamp: 'FernandoOlivero 2/7/2012 23:37'!
underlineOn: aCairoCanvas at: aPoint extending: anExtent
	self
		primShowErrorUnderline: aCairoCanvas
		atX: aPoint x
		y: aPoint y
		width: anExtent x 
		height: anExtent y! !

!AthensPangoCairoParagraph methodsFor: 'geometry' stamp: 'FernandoOlivero 1/18/2012 01:15'!
wrapWidth
	| h |
	h := self primGetWidth.
	h = -1 ifTrue:[ ^ h] ifFalse:[ ^ h / PANGO_SCALE]! !

!AthensPangoCairoParagraph methodsFor: 'geometry' stamp: 'FernandoOlivero 2/12/2012 18:03'!
wrapWidth: aPositiveIntOrMinusOne
	aPositiveIntOrMinusOne = -1 
		ifTrue:[self primSetWidth: -1 ]
		ifFalse:[self primSetWidth: aPositiveIntOrMinusOne rounded	* PANGO_SCALE]
	 ! !

AthensPangoCairoText subclass: #AthensPangoCairoParagraphLine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-PangoCairo'!

!AthensPangoCairoParagraphLine classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 1/17/2012 12:14'!
at: aLineNumber in: anAthensPangoCairoPar
	
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	^ self pangoNbCall: #(PangoLayoutLine  pango_layout_get_line_readonly (PangoLayout anAthensPangoCairoPar, int aLineNumber))! !

!AthensPangoCairoParagraphLine methodsFor: 'accessing' stamp: 'FernandoOlivero 2/5/2012 20:14'!
extent
	^ self getExtents second extent rounded ! !

!AthensPangoCairoParagraphLine methodsFor: 'accessing' stamp: 'FernandoOlivero 2/5/2012 20:03'!
getExtents
	| inkRect inkRectArray logicalRect logicalRectArray|
	
	inkRect  := AthensPangoCairoRectangle new.
	inkRectArray := inkRect asByteArray.
	
	logicalRect  := AthensPangoCairoRectangle new.
	logicalRectArray := logicalRect asByteArray.
	
	self primGetExtentsInk: inkRectArray logical: logicalRectArray.
	
	inkRect readFrom: inkRectArray.
	logicalRect readFrom: logicalRectArray.
	
	^ {inkRect. logicalRect}.! !

!AthensPangoCairoParagraphLine methodsFor: 'accessing' stamp: 'FernandoOlivero 2/5/2012 20:13'!
height
	^ self extent y ! !

!AthensPangoCairoParagraphLine methodsFor: 'apply primitives' stamp: 'FernandoOlivero 2/5/2012 20:00'!
primGetExtentsInk: anInkRect logical: aLogicalRect
	
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self pangoNbCall: #(void  pango_layout_line_get_extents (
		self,
        ByteArray anInkRect,
        ByteArray aLogicalRect))! !

!AthensPangoCairoParagraphLine methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/17/2012 12:07'!
primLayoutPath: aCairoCanvas 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	"Adds the text in a PangoLayout to the current path in the specified cairo context. The top-left corner of the PangoLayout will be at the current point of the cairo context."
	^ self nbCall: #(void pango_cairo_layout_line_path (
		cairo_t aCairoCanvas, 
		self) )
! !

!AthensPangoCairoParagraphLine methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/17/2012 12:07'!
primShowLayout: aCairoCanvas 
	"The top-left corner of the PangoLayout will be drawn at the current point of the cairo context."
	
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void pango_cairo_show_layout_line  (
			cairo_t aCairoCanvas, 
			self) )
! !

!AthensPangoCairoParagraphLine methodsFor: 'apply primitives' stamp: 'FernandoOlivero 1/17/2012 12:07'!
primUnref
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	self pangoNbCall: #(void  pango_layout_line_unref (self))
! !

!AthensPangoCairoText methodsFor: 'initialization' stamp: 'FernandoOlivero 1/17/2012 14:56'!
destroy
	"Decrease the reference count of a PangoLayoutLine by one. If the result is zero, the line and all associated memory will be freed."
	self primUnref
 ! !

!AthensPangoCairoText methodsFor: 'drawing' stamp: 'FernandoOlivero 4/7/2012 12:15'!
drawOn: aCanvas
	aCanvas setPathMatrix.
	self
		primUpdateLayout: aCanvas ;
		primShowLayout: aCanvas ! !

!AthensPangoCairoText methodsFor: 'initialization' stamp: 'FernandoOlivero 1/17/2012 12:06'!
finalize
	handle value = 0 ifFalse: [
		self destroy.
		handle value: 0
		 ].
! !

!AthensPangoCairoText methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 12:12'!
readOnlyLineAt: aLineNumber
	^ AthensPangoCairoParagraphLine
		at: aLineNumber
		in: self. 
	! !

!PangoCairoTypes classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 2/5/2012 19:20'!
initialize
"
self initialize
"
	PangoAlignment := PangoEllipsizeMode :=  PangoWrapMode := PangoGravity := PangoDirection := gboolean := #int.  
	PangoLayout := #AthensPangoCairoParagraph.
	PangoFontDescription := #AthensPangoCairoFontDescription. 
	PangoTabArray := #AthensPangoCairoTabs.
	".

	PangoFontMap := #NBPangoFontMap.
	PangoLanguage := #NBPangoLanguage.
	PangoCairoFontMap := #NBPangoCairoFontMap.
	PangoContext := #AthensPangoContext."
	PangoLayoutLine := #AthensPangoCairoParagraphLine.
	PangoLayoutIter := #AthensPangoCairoParagraphIterator.
	 ! !

Object subclass: #ParagraphDescription
	uses: TPangoCairoLibrary
	instanceVariableNames: 'spacing tabs alignment ellipsize wrap indentation justify'
	classVariableNames: ''
	poolDictionaries: 'PangoCairoConstants PangoCairoTypes'
	category: 'Athens-PangoCairo'!

ParagraphDescription class
	uses: TPangoCairoLibrary classTrait
	instanceVariableNames: ''!

!ParagraphDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 14:15'!
alignment

	^ alignment! !

!ParagraphDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 14:41'!
alignment: anObject
	"left,center or right"
	alignment := anObject! !

!ParagraphDescription methodsFor: 'private' stamp: 'FernandoOlivero 1/17/2012 14:48'!
alignmentValue
	^alignment caseOf:{
		['left']->[PANGO_ALIGN_LEFT].
  		['center']->[PANGO_ALIGN_CENTER].
  		['right']->[PANGO_ALIGN_RIGHT].
	}! !

!ParagraphDescription methodsFor: 'private' stamp: 'FernandoOlivero 1/17/2012 14:49'!
alignmentValueFrom: anInt 
	^anInt caseOf:{
		[PANGO_ALIGN_LEFT]->['left'].
  		[PANGO_ALIGN_CENTER]->['center'].
  		[PANGO_ALIGN_RIGHT]->['right'].
	}! !

!ParagraphDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 14:39'!
beJustified
	self justify: true.! !

!ParagraphDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 14:15'!
ellipsize

	^ ellipsize! !

!ParagraphDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 15:33'!
ellipsize: anObject
	"none, start, middle, end"

"Sets the type of ellipsization being performed for layout. Depending on the ellipsization mode ellipsize text is removed from the start, middle, or end of text so they fit within the width and height of layout set with pango_layout_set_width() and pango_layout_set_height().

If the layout contains characters such as newlines that force it to be layed out in multiple paragraphs, then whether each paragraph is ellipsized separately or the entire layout is ellipsized as a whole depends on the set height of the layout. See pango_layout_set_height() for details."

	ellipsize := anObject! !

!ParagraphDescription methodsFor: 'private' stamp: 'FernandoOlivero 3/2/2012 16:59'!
ellipsizeValue
	^ellipsize caseOf:{
	['none'] -> [PANGO_ELLIPSIZE_NONE].
  	['start']->[PANGO_ELLIPSIZE_START].
  	['middle']->[PANGO_ELLIPSIZE_MIDDLE].
	['end']->[ PANGO_ELLIPSIZE_END].
	}! !

!ParagraphDescription methodsFor: 'private' stamp: 'FernandoOlivero 1/17/2012 14:51'!
ellipsizeValueFrom: anInt 
	^anInt caseOf:{
	[PANGO_ELLIPSIZE_NONE]->['none'].
  	[PANGO_ELLIPSIZE_START]->['start'].
  	[PANGO_ELLIPSIZE_MIDDLE]->['middle'].
	[ PANGO_ELLIPSIZE_END]->['end'].
	}! !

!ParagraphDescription methodsFor: 'private' stamp: 'FernandoOlivero 1/17/2012 19:01'!
getTabsFrom: anAthensParagraph
	| tabsArray |
	tabsArray  := AthensPangoCairoTabs getFrom: anAthensParagraph .
	tabs := tabsArray asArray collect:[:e| e / PANGO_SCALE].
	tabsArray finalize.! !

!ParagraphDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 15:54'!
indentation

	^ indentation /  PANGO_SCALE! !

!ParagraphDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 15:54'!
indentation: anObject
	
"Sets the width in Pango units to indent each paragraph. A negative value of indent will produce a hanging indentation. That is, the first line will have the full width, and subsequent lines will be indented by the absolute value of indent.

The indent setting is ignored if layout alignment is set to PANGO_ALIGN_CENTER."

	indentation := anObject * PANGO_SCALE! !

!ParagraphDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 15:11'!
justify
	^ justify = 1
		! !

!ParagraphDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 15:23'!
justify: anObject
	anObject isNumber
		ifTrue:[ justify := anObject]
		ifFalse:[
			anObject
				ifTrue:[ justify := 1 ]
				ifFalse:[ justify := 0 ] ].! !

!ParagraphDescription methodsFor: 'drawing' stamp: 'FernandoOlivero 4/28/2012 18:56'!
loadOn: anAthensParagraph
	justify notNil ifTrue:[ self primSetJustifyOn: anAthensParagraph].
	wrap notNil ifTrue:[ self primSetWrap: self wrapValue on: anAthensParagraph].
	tabs notNil ifTrue:[ self setTabsOn: anAthensParagraph ].	
	spacing notNil ifTrue:[ self primSetSpacingOn: anAthensParagraph ].
	indentation notNil ifTrue:[ self primSetIndentOn: anAthensParagraph].
	ellipsize notNil ifTrue:[ self primSetEllipsize: self ellipsizeValue on: anAthensParagraph].
	alignment notNil ifTrue:[ self primSetAlignment: self alignmentValue on: anAthensParagraph].
	! !

!ParagraphDescription methodsFor: 'primitives' stamp: 'FernandoOlivero 1/17/2012 15:19'!
primGetAlignmentFrom: anAthensParagraph	
	
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self pangoNbCall: #(PangoAlignment  pango_layout_get_alignment (PangoLayout anAthensParagraph))
					! !

!ParagraphDescription methodsFor: 'primitives' stamp: 'FernandoOlivero 1/17/2012 15:05'!
primGetEllipsizeFrom: anAthensParagraph
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self pangoNbCall: #(PangoEllipsizeMode  pango_layout_get_ellipsize  (PangoLayout anAthensParagraph))
 ! !

!ParagraphDescription methodsFor: 'primitives' stamp: 'FernandoOlivero 1/17/2012 14:34'!
primGetIndentFrom: anAthensParagraph
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self pangoNbCall: #(int  pango_layout_get_indent (PangoLayout anAthensParagraph))
	! !

!ParagraphDescription methodsFor: 'primitives' stamp: 'FernandoOlivero 1/17/2012 15:12'!
primGetJustifyFrom: anAthensParagraph
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self pangoNbCall: #(gboolean  pango_layout_get_justify (PangoLayout anAthensParagraph))
! !

!ParagraphDescription methodsFor: 'primitives' stamp: 'FernandoOlivero 1/17/2012 14:35'!
primGetSpacingFrom: anAthensParagraph 
<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self pangoNbCall: #(int  pango_layout_get_spacing (PangoLayout anAthensParagraph))
					! !

!ParagraphDescription methodsFor: 'primitives' stamp: 'FernandoOlivero 1/17/2012 14:35'!
primGetWrapFrom: anAthensParagraph
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self pangoNbCall: #(PangoWrapMode  pango_layout_get_wrap (PangoLayout anAthensParagraph))
! !

!ParagraphDescription methodsFor: 'primitives' stamp: 'FernandoOlivero 1/17/2012 15:19'!
primSetAlignment: aMode on: anAthensParagraph

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
 	self pangoNbCall: #(void pango_layout_set_alignment (
					PangoLayout anAthensParagraph, 
					PangoAlignment aMode ))
					! !

!ParagraphDescription methodsFor: 'primitives' stamp: 'FernandoOlivero 1/17/2012 15:19'!
primSetEllipsize: aMode on: anAthensParagraph

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
 	self pangoNbCall: #(void  pango_layout_set_ellipsize   (
					PangoLayout anAthensParagraph,
					PangoEllipsizeMode aMode) )
 					! !

!ParagraphDescription methodsFor: 'primitives' stamp: 'FernandoOlivero 1/17/2012 15:55'!
primSetIndentOn: anAthensParagraph

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self pangoNbCall: #(void  pango_layout_set_indent (
					PangoLayout anAthensParagraph,
					int indentation) ) 
	! !

!ParagraphDescription methodsFor: 'primitives' stamp: 'FernandoOlivero 1/17/2012 15:19'!
primSetJustifyOn: anAthensParagraph
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self pangoNbCall: #(void  pango_layout_set_justify (
					PangoLayout anAthensParagraph,
					gboolean justify ))
! !

!ParagraphDescription methodsFor: 'primitives' stamp: 'FernandoOlivero 1/17/2012 15:22'!
primSetSpacingOn: anAthensParagraph

 	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
		
	self pangoNbCall: #(void  pango_layout_set_spacing (
					PangoLayout anAthensParagraph,
					int spacing) )
! !

!ParagraphDescription methodsFor: 'primitives' stamp: 'FernandoOlivero 1/17/2012 15:19'!
primSetWrap: aMode on: anAthensParagraph

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self pangoNbCall: #(void  pango_layout_set_wrap (
					PangoLayout anAthensParagraph,
					PangoWrapMode aMode) )  
					! !

!ParagraphDescription methodsFor: 'drawing' stamp: 'FernandoOlivero 4/28/2012 19:01'!
readFrom: anAthensParagraph
	self justify:( self primGetJustifyFrom: anAthensParagraph).
	wrap  := self wrapValueFrom:(self primGetWrapFrom: anAthensParagraph).
	tabs  := self getTabsFrom: anAthensParagraph.
	spacing := (self primGetSpacingFrom: anAthensParagraph).
	indentation := self primGetIndentFrom: anAthensParagraph.
	ellipsize := self ellipsizeValueFrom:(self primGetEllipsizeFrom: anAthensParagraph).
	alignment := self alignmentValueFrom:(self primGetAlignmentFrom: anAthensParagraph).
	! !

!ParagraphDescription methodsFor: 'private' stamp: 'FernandoOlivero 1/17/2012 18:36'!
readTabsFrom: anAthensParagraph
	| tabsArray | 
	tabsArray := AthensPangoCairoTabs from: anAthensParagraph.
	tabsArray loadOn: anAthensParagraph.
	tabsArray finalize.
		! !

!ParagraphDescription methodsFor: 'primitives' stamp: 'FernandoOlivero 1/17/2012 23:21'!
setTabsOn: anAthensParagraph
	| tabsArray | 
	tabsArray := AthensPangoCairoTabs	tabs: tabs.
	tabsArray loadOn: anAthensParagraph.
	tabsArray finalize.
		! !

!ParagraphDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 16:48'!
spacing

	^ spacing / PANGO_SCALE! !

!ParagraphDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 16:48'!
spacing: anObject

	spacing := anObject * PANGO_SCALE! !

!ParagraphDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 14:15'!
tabs

	^ tabs! !

!ParagraphDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 18:31'!
tabs: anObject
	"an array of tab offsets"
	tabs := anObject! !

!ParagraphDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 14:15'!
wrap

	^ wrap! !

!ParagraphDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 14:53'!
wrap: anObject
	"word, char, wordChar"
	wrap := anObject! !

!ParagraphDescription methodsFor: 'private' stamp: 'FernandoOlivero 1/17/2012 14:47'!
wrapValue
	^wrap caseOf:{
		['word']->[PANGO_WRAP_WORD ].
  		['char']->[PANGO_WRAP_CHAR ].
  		['wordChar']->[PANGO_WRAP_WORD_CHAR ].
	}! !

!ParagraphDescription methodsFor: 'private' stamp: 'FernandoOlivero 1/17/2012 14:48'!
wrapValueFrom: anInt
	^anInt caseOf:{
		[PANGO_WRAP_WORD ]->['word'].
  		[PANGO_WRAP_CHAR ]->['char'].
  		[PANGO_WRAP_WORD_CHAR ]->['wordChar'].
	}! !
PangoCairoConstants initialize!
PangoCairoTypes initialize!
